\documentclass[a4paper,titlepage]{article}

\usepackage{t1enc}
\usepackage[pdftex]{graphicx}
\usepackage{times}
\usepackage{float}

\title{Darn v1.0\\ 
{\Large A weighted constraint solver for RNA motif localization}\\
Development manual}
\author{INRA Toulouse, France}
\date{February 10, 2010} 


\begin{document}
{\fbox{
\begin{minipage}{1\textwidth}
\maketitle
\end{minipage}
}}

\tableofcontents

\newpage
\section{Presentation}
Darn is a RNA motif search tool. It finds all the subsequences that match a specified motif on some input genomic sequence(s).\\
\\
Darn development is supported by a Forge (\texttt\scriptsize{https://mulcyber.toulouse.inra.fr/projects/m-hz}). The source code is managed, a Bug and Feature tracker is defined and users can find downloadable files.\\
\\ 
A website \texttt\scriptsize{{http://carlit.toulouse.inra.fr/Darn}} allows restricted online use. The source code of the site is also available on the Forge project.\\
\\
Darn was developped by Matthias Zytnicki during his PhD in the BIA lab at INRA Toulouse, France. A ligth refactoring was done in 2010 before tagging version 1.0 (February 10, 2010).\\
\\
Darn is written in C++ for Linux systems and is distribued under the GNU GPL license.\\


\section{Specification}
The inputs of the software are:
\begin{itemize}
\item genomic sequence(s) in IUPAC nucleotide code multiFASTA format.
\item if a duplex search is required, a genomic sequence also in IUPAC nucleotide code.
\end{itemize}
By default, the outputs of the software are:
\begin{itemize}
\item found regions,
\item comments.
\end{itemize}
All the outputs of the software are put on the default output stream.\\
\\
The found regions could be provided in various formats: by default a specific format but also a multiFASTA, a GFF and an easy parsed formats.\\
\\
The software has no graphical interface, it is usable by command line.\\


\section{Conception}
The UML class diagram is the following.\\
\begin{figure}[H]
  \begin{center}
    \includegraphics[width=13cm]{DvtManual_images/classes}
  \end{center}
\end{figure}
\noindent
The main class is the Network class with its method \texttt{explore} that launches the search.\\
The constraints are defined by a class tree which an abstract class called \texttt{AbstractConstraint} as root.\\
The search algorithm is defined by a class tree which the \texttt{Backtrack} class as root.\\

\section{Implementation}
A \texttt{Makefile} file allows to compile, to install/uninstall the software and to run tests.\\
The heart of software is compiled using \textbf{makedepend} and \textbf{g++}.\\
The motif description language is compiled using \textbf{flex} and \textbf{bison} parser.\\
The Vienna RNA library (Hofacker IL. \textit{Vienna RNA secondary structure server}. Nucleic Acids Res. 31(13), 2003) is used and provided in the code and compile with \textbf{gcc}.\\
The documentation is generated with \textbf{pdflatex} except the CodeManual that was generated with \textbf{Doxygen}.\\
\\
A development trace is available using the \texttt{-VVVV} argument.\\ 

\section{Test}
Non regression functional tests had been defined and callable by the following command:\\
\hspace*{1cm}\texttt{make check}\\
The tests are launched by a shell script \texttt{run\_tests.sh} that needs to be parameterized before being launched.\\
The script compares for each test the current output with a reference one. A test succeed if there is no difference. In the other case, the test fails and the current output is written in a tests/test<n>.out file that has to be compared  with its reference file tests/test<n>.ref (for example the developper could use the command \texttt{tkdiff test1.out test1.ref}). \\
\\
The tests are defined in order to test each defined arguments. Here is the description of the defined arguments for each test:\\
\hspace*{1cm} test1: -s sample.fa -d tRNA\_Bacteria.des -u -t\\
\hspace*{1cm} test2: -s sample.fa -d tRNA\_Bacteria.des -n B -f P\\
\hspace*{1cm} test3: -s sample.fa -d Lysine -n R -f F\\
\hspace*{1cm} test4: -s sample.fa -d test\_duplex.des -x test\_duplex.fa -f G \\
\hspace*{1cm} test5: -s sample.fa -d test\_duplex.des -x test\_duplex.fa -v -c -e\\



\end{document}
